//Copyright (c) 2000 QUARTIC Inc. [L NH[eBbN]
//XvCgo
#include <ddraw.h>			//DDRAW VXewb_
#include <stdio.h>
#include "DIRECTX.H"		//DDRAW ֘Awb_
#include "XSP2lib.H"
#include "SPASSION.H"
//#include "SUB.H"			//

static short xsp_num=0,xobj_num=0;
short	xsp_max=0;

#define MAX_SP_NUM	65536
static XSP xsp_buffer[MAX_SP_NUM];
static XOBJ_REF_DAT *ref_buffer;			/* t@Xf[^ */
IDirectDrawSurface *lpDDSSprite[MAX_SP_NUM];	// ItXN[T[tFCXIuWFNg
BOOL SurfaceCreateError( char *mess );

void RestoreSpriteSurfaces( void )
{
	void LoadXSPFile( void );

	for(int i=0;i<MAX_SP_NUM;i++){
		RELEASE(lpDDSSprite[i]);
	}
	xsp_max=0;
	LoadXSPFile();
}

void	xsp_on( void )
{
	for(int i=0;i<MAX_SP_NUM;i++)
		RELEASE(lpDDSSprite[i]);
}
void	xsp_off( void )
{
	for(int i=0;i<MAX_SP_NUM;i++)
		RELEASE(lpDDSSprite[i]);
}
// BMPt@Cǂݍ
/* ǂݍ݂Ɏsꍇ͂ȂÎŒ */
HBITMAP LoadBMP( char *fname )
{
	HBITMAP		hbm;

	hbm=(HBITMAP)LoadImage(GetModuleHandle(NULL),fname,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
	if( !hbm )
		hbm=(HBITMAP)LoadImage(NULL,fname,IMAGE_BITMAP,0,0,LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if( !hbm ){
		void game_end( void );
		static char e[256];
		error_level = ERROR_FILE;
		error_message = e;
		sprintf (e, "t@C %s ǂݍ߂܂\n", fname);
		game_end();
		return (HBITMAP)FALSE;
	}
	return (HBITMAP)hbm;
}

//	DirectDraw̃ItXN[ɃXvCgobt@ݒ肷
//void xsp_pcgdat_set( void *pcg_dat, 	/* obff[^w */
//					 char *pcg_alt,		/* obfzuǗe[uw */
//					 short sp_num )		/* obfzuǗe[ũTCYw */
short LoadSP( char *fname )
{
//	extern HWND	hWnd;
	DDSURFACEDESC ddsd;
	char temp_fname[255];
	short sp_no=xsp_max,x_max,y_max;

	ZeroMemory( &ddsd, sizeof( ddsd ) );
	ddsd.dwSize = sizeof( ddsd );
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH|DDSD_HEIGHT;
	ddsd.dwWidth  = 16;		// XvCgT[tFX
	ddsd.dwHeight = 16;		// XvCgT[tFXc
	ddsd.ddsCaps.dwCaps =DDSCAPS_OFFSCREENPLAIN;

	// XvCgt@Cǂݍ
	strcpy (temp_fname, fname);
	strcat (temp_fname, ".BMP");
	HBITMAP		hbm;
	BITMAP		bm;
	if( !(hbm=LoadBMP( temp_fname )) )return FALSE;
	GetObject(hbm,sizeof(bm),&bm);

	x_max=bm.bmWidth/16;
	y_max=bm.bmHeight/16;
	for(int y=0;y<y_max;y++){
		for(int x=0;x<x_max;x++){
			// XvCgT[tFX̐
			if( lpDD->CreateSurface( &ddsd , &lpDDSSprite[xsp_max] , NULL)!=DD_OK )	// XvCgT[tFX
				return SurfaceCreateError( "XvCg" );
			//	DirectDraw̃ItXN[ɃXvCgobt@]
			HDC hdcBitmap;
			HDC hdcSurf;
			hdcBitmap=CreateCompatibleDC(NULL);
			SelectObject(hdcBitmap,hbm);
			if( lpDDSSprite[xsp_max]->GetDC(&hdcSurf)==DD_OK ){
				BitBlt(hdcSurf,0,0,16,16,hdcBitmap,x*16,y*16,SRCCOPY);
				lpDDSSprite[xsp_max]->ReleaseDC(hdcSurf);
			}else return 0;
			DeleteDC(hdcBitmap);

			// J[L[ݒ
			DDCOLORKEY          ddck;				// J[L[
			ddck.dwColorSpaceLowValue  = 0;			// w
			ddck.dwColorSpaceHighValue = 0;
			lpDDSSprite[xsp_max]->SetColorKey(DDCKEY_SRCBLT, &ddck);
			xsp_max++;
		}
	}
	return sp_no;
}

void	xsp_objdat_set( void *ref_dat )
{
	ref_buffer=(XOBJ_REF_DAT *)ref_dat;
}

short xsp_out( void )
{
	short	i,j,dx1,dy1,dx2,dy2,sx1=0,sy1=0,sx2=16,sy2=16;
	short	out_num=xsp_num;
	XSP		tmp;
	RECT rcDest,rcSrc;
	DDBLTFX	ddbltfx;				//Blt ̃Rg[p\
	extern short	bg_y;

	//ŏɗD揇ʂɏ]ă\[g
	for(i=0;i<xsp_num;i++){
		for(j=i+1;j<xsp_num;j++){
			if( (char)xsp_buffer[i].info > (char)xsp_buffer[j].info ){
				tmp=xsp_buffer[i];
				xsp_buffer[i]=xsp_buffer[j];
				xsp_buffer[j]=tmp;
			}
		}
	}
	ZeroMemory(&ddbltfx,sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);					//\̂̃TCY肷
	//]
	for(i=0;i<xsp_num;i++){
		//PXvCg
		if( !xsp_buffer[i].type ){
			short x=xsp_buffer[i].x;
			short y=xsp_buffer[i].y-bg_y;
//			dx1=x;dy1=y;dx2=x+16;dy2=y+16;			//ʂ͂
			dx1=x-16;dy1=y-16;dx2=x;dy2=y;			//X68k݊
			//SɉʊOȂ΂
			if( dx1>319 || dy1>239 || dx2<0 || dy2<0 ){
				continue;
			}else{
				sx1=0;sy1=0;sx2=16;sy2=16;
				switch( xsp_buffer[i].info&0xF000 ){
				case 0:
					ddbltfx.dwDDFX=0;
					if( dx1<  0 ){sx1=-dx1;dx1=0;}
//					if( dx2>319 ){sx2=320-dx1;dx2=320;}		//񂠂肦Ȃ̂ŏȗ
					if( dy1<  0 ){sy1=-dy1;dy1=0;}
					if( dy2>239 ){sy2=240-dy1;dy2=240;}
					break;
				case 0x4000:
					ddbltfx.dwDDFX=DDBLTFX_MIRRORLEFTRIGHT;
					if( dx1<  0 ){sx2=16+dx1;dx1=0;}
					if( dx2>319 ){sx1=dx2-320;dx2=320;}
					if( dy1<  0 ){sy1=-dy1;dy1=0;}
					if( dy2>239 ){sy2=240-dy1;dy2=240;}
					break;
				case 0x8000:
					ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN;
					if( dx1<  0 ){sx1=-dx1;dx1=0;}
//					if( dx2>319 ){sx2=320-dx1;dx2=320;}		//񂠂肦Ȃ̂ŏȗ
					if( dy1<  0 ){sy2=16+dy1;dy1=0;}
					if( dy2>239 ){sy1=dy2-239;dy2=240;}
					break;
				case 0xC000:
					ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN|DDBLTFX_MIRRORLEFTRIGHT;
					if( dx1<  0 ){sx2=16+dx1;dx1=0;}
					if( dx2>319 ){sx1=dx2-320;dx2=320;}
					if( dy1<  0 ){sy2=16+dy1;dy1=0;}
					if( dy2>239 ){sy1=dy2-239;dy2=240;}
					break;
				}
				SetRect(&rcDest,dx1,dy1,dx2,dy2);
				SetRect(&rcSrc, sx1,sy1,sx2,sy2);
				lpDDSBack->Blt(&rcDest,lpDDSSprite[xsp_buffer[i].pt],&rcSrc,DDBLT_KEYSRC | DDBLT_WAIT | DDBLT_DDFX,&ddbltfx);
			}
		//XvCg
		}else{
			short pt=xsp_buffer[i].pt;					//p^[ԍ
			short x=xsp_buffer[i].x,y=xsp_buffer[i].y-bg_y;	//ŏ̈ʒu
			XOBJ_FRM_DAT *frm_ptr=(XOBJ_FRM_DAT *)ref_buffer[pt].ptr;		//t[obt@̃AhX
			//㉺E]B̂߂ɏ璷ȃR[hɂȂĂ܂
			switch( xsp_buffer[i].info&0xF000 ){
			case 0:
				for( j=0;j<ref_buffer[pt].num;j++ ){
					x+=frm_ptr->vx;
					y+=frm_ptr->vy;
//					dx1=x;dy1=y;dx2=x+16;dy2=y+16;		//ʂ͂
					dx1=x-16;dy1=y-16;dx2=x;dy2=y;		//X68k݊
					//SɉʊOȂ΂
					if( dx1>319 || dy1>239 || dx2<0 || dy2<0 ){
						frm_ptr++;
						continue;
					}else{
						sx1=0;sy1=0;sx2=16;sy2=16;
						switch( frm_ptr->rv&0xF000 ){
						case 0:
							ddbltfx.dwDDFX=0;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						case 0x4000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						case 0x8000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						case 0xC000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN|DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						}
						SetRect(&rcDest,dx1,dy1,dx2,dy2);
						SetRect(&rcSrc, sx1,sy1,sx2,sy2);
						lpDDSBack->Blt(&rcDest,lpDDSSprite[frm_ptr->pt],&rcSrc,DDBLT_KEYSRC | DDBLT_WAIT | DDBLT_DDFX,&ddbltfx);
					}
					frm_ptr++;
				}
				break;
			case 0x4000:
				for( j=0;j<ref_buffer[pt].num;j++ ){
					x-=frm_ptr->vx;
					y+=frm_ptr->vy;
//					dx1=x;dy1=y;dx2=x+16;dy2=y+16;		//ʂ͂
					dx1=x-16;dy1=y-16;dx2=x;dy2=y;		//X68k݊
					if( dx1>319 || dy1>239 || dx2<0 || dy2<0 ){
						frm_ptr++;
						continue;
					}else{
						sx1=0;sy1=0;sx2=16;sy2=16;
						switch( frm_ptr->rv&0xF000 ){
						case 0:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						case 0x4000:
							ddbltfx.dwDDFX=0;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						case 0x8000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN|DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						case 0xC000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						}
						SetRect(&rcDest,dx1,dy1,dx2,dy2);
						SetRect(&rcSrc, sx1,sy1,sx2,sy2);
						lpDDSBack->Blt(&rcDest,lpDDSSprite[frm_ptr->pt],&rcSrc,DDBLT_KEYSRC | DDBLT_WAIT | DDBLT_DDFX,&ddbltfx);
					}
					frm_ptr++;
				}
				break;
			case 0x8000:
				for( j=0;j<ref_buffer[pt].num;j++ ){
					x+=frm_ptr->vx;
					y-=frm_ptr->vy;
//					dx1=x;dy1=y;dx2=x+16;dy2=y+16;		//ʂ͂
					dx1=x-16;dy1=y-16;dx2=x;dy2=y;		//X68k݊
					if( dx1>319 || dy1>239 || dx2<0 || dy2<0 ){
						frm_ptr++;
						continue;
					}else{
						sx1=0;sy1=0;sx2=16;sy2=16;
						switch( frm_ptr->rv&0xF000 ){
						case 0:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						case 0x4000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN|DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						case 0x8000:
							ddbltfx.dwDDFX=0;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						case 0xC000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						}
						SetRect(&rcDest,dx1,dy1,dx2,dy2);
						SetRect(&rcSrc, sx1,sy1,sx2,sy2);
						lpDDSBack->Blt(&rcDest,lpDDSSprite[frm_ptr->pt],&rcSrc,DDBLT_KEYSRC | DDBLT_WAIT | DDBLT_DDFX,&ddbltfx);
					}
					frm_ptr++;
				}
				break;
			case 0xC000:
				for( j=0;j<ref_buffer[pt].num;j++ ){
					x-=frm_ptr->vx;
					y-=frm_ptr->vy;
//					dx1=x;dy1=y;dx2=x+16;dy2=y+16;		//ʂ͂
					dx1=x-16;dy1=y-16;dx2=x;dy2=y;		//X68k݊
					if( dx1>319 || dy1>239 || dx2<0 || dy2<0 ){
						frm_ptr++;
						continue;
					}else{
						sx1=0;sy1=0;sx2=16;sy2=16;
						switch( frm_ptr->rv&0xF000 ){
						case 0:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN|DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						case 0x4000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORUPDOWN;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy2=16+dy1;dy1=0;}
							if( dy2>239 ){sy1=dy2-240;dy2=240;}
							break;
						case 0x8000:
							ddbltfx.dwDDFX=DDBLTFX_MIRRORLEFTRIGHT;
							if( dx1<  0 ){sx2=16+dx1;dx1=0;}
							if( dx2>319 ){sx1=dx2-320;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						case 0xC000:
							ddbltfx.dwDDFX=0;
							if( dx1<  0 ){sx1=-dx1;dx1=0;}
							if( dx2>319 ){sx2=320-dx1;dx2=320;}
							if( dy1<  0 ){sy1=-dy1;dy1=0;}
							if( dy2>239 ){sy2=240-dy1;dy2=240;}
							break;
						}
						SetRect(&rcDest,dx1,dy1,dx2,dy2);
						SetRect(&rcSrc, sx1,sy1,sx2,sy2);
						lpDDSBack->Blt(&rcDest,lpDDSSprite[frm_ptr->pt],&rcSrc,DDBLT_KEYSRC | DDBLT_WAIT | DDBLT_DDFX,&ddbltfx);
					}
					frm_ptr++;
				}
				break;
			}
		}
	}
	xsp_num=0;

	return out_num;
}

void xobj_set_st( void *xsp_ )
{
	XSP	*xsp=(XSP *)xsp_;
	if( xsp_num<MAX_SP_NUM && xsp->pt<xsp_max ){
		xsp_buffer[xsp_num].x   =xsp->x;
		xsp_buffer[xsp_num].y   =xsp->y;
		xsp_buffer[xsp_num].pt  =xsp->pt;
		xsp_buffer[xsp_num].info=xsp->info;
		xsp_buffer[xsp_num].type=1;
		xsp_num++;
	}
}
void	xobj_set(short x,short y,short pt,short info)
{
	if( xsp_num<MAX_SP_NUM && pt<xsp_max ){
		xsp_buffer[xsp_num].x   =x;
		xsp_buffer[xsp_num].y   =y;
		xsp_buffer[xsp_num].pt  =pt;
		xsp_buffer[xsp_num].info=info;
		xsp_buffer[xsp_num].type=1;
		xsp_num++;
	}
}

short xsp_set_st( void *xsp_ )
{
	XSP	*xsp=(XSP *)xsp_;
	if( xsp_num<MAX_SP_NUM && xsp->pt<xsp_max ){
		xsp_buffer[xsp_num].x   =xsp->x;
		xsp_buffer[xsp_num].y   =xsp->y;
		xsp_buffer[xsp_num].pt  =xsp->pt;
		xsp_buffer[xsp_num].info=xsp->info;
		xsp_buffer[xsp_num].type=0;
		xsp_num++;
	}else
		return 0;
	return 1;
}
short	xsp_set(short x,short y,short pt,short info)
{
	if( xsp_num<MAX_SP_NUM && pt<xsp_max ){
		xsp_buffer[xsp_num].x   =x;
		xsp_buffer[xsp_num].y   =y;
		xsp_buffer[xsp_num].pt  =pt;
		xsp_buffer[xsp_num].info=info;
		xsp_buffer[xsp_num].type=0;
		xsp_num++;
	}else
		return 0;
	return 1;
}
